<template lang="pug">
  div
    v-layout(row wrap)
      v-flex(xs12 sm12 md12)
        p.b-content__title-section Выберите диапазон дат:

    v-layout(row wrap justify-space-between)
      v-flex(xs12 sm6 md6 d-flex)
        date-picker(
          v-model="startDate"
          label="Дата начала"
          :defaultValue="defaultStartDate"
          :errorMessage="startDateErrors"
        )

      v-flex(xs12 sm6 md6 d-flex)
        date-picker(
          v-model="finishDate"
          label="Дата конца"
          :defaultValue="defaultFinishDate"
          :errorMessage="finishDateErrors"
        )
    //- time-from-to
    files-list(
      hasTopSpace="true"
      :loadAction="runLoadReports"
      :files="getFiles"
      :fileServer="getFileServer"
    )
</template>

<script>
import { mapGetters } from 'vuex';
import moment from 'moment';
import DatePicker from '../components/datepicker/index.vue';
import FilesList from '../components/files-list/index.vue';

export default {
  name: 'MedicsFull',
  components: {
    DatePicker,
    FilesList
  },
  computed: {
    ...mapGetters([
      'getFileServer'
    ]),
    ...mapGetters('medicsFull', ['getFiles']),
    startDate: {
      get() {
        return this.$store.getters['medicsFull/getStartDate'];
      },
      set(value) {
        this.$store.commit('medicsFull/setStartDate', value);
      },
    },
    finishDate: {
      get() {
        return this.$store.getters['medicsFull/getFinishDate'];
      },
      set(value) {
        this.$store.commit('medicsFull/setFinishDate', value);
      },
    },
    startDateErrors() {
      const errors = [];
      if (!this.$v.startDate.$dirty) return errors;
      if (!this.$v.startDate.isDate) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.startDate.isAfterDate) {
        errors.push('Дата начала должна быть позже даты конца.');
      }
      return errors;
    },
    finishDateErrors() {
      const errors = [];
      if (!this.$v.finishDate.$dirty) return errors;
      if (!this.$v.finishDate.isDate) {
        errors.push('Обязательно для заполнения.');
      }
      if (!this.$v.finishDate.isBeforeDate) {
        errors.push('Дата конца должна быть позже даты начала.');
      }
      return errors;
    },
    defaultStartDate() {
      return moment(this.$store.getters['medicsFull/getStartDate'], 'DD.MM.YYYY').isValid()
        ? moment(this.$store.getters['medicsFull/getStartDate'], 'DD.MM.YYYY')
        : moment().subtract(1, 'month').startOf('month');
    },
    defaultFinishDate() {
      return moment(this.$store.getters['medicsFull/getFinishDate'], 'DD.MM.YYYY').isValid()
        ? moment(this.$store.getters['medicsFull/getFinishDate'], 'DD.MM.YYYY')
        : moment().startOf('month');
    },
  },
  validations: {
    startDate: {
      isDate: value =>  moment(value, 'DD.MM.YYYY').isValid(),
      isAfterDate(value) {
        return moment(value, 'DD.MM.YYYY')
          .isSameOrBefore(moment(this.finishDate, 'DD.MM.YYYY'));
      },
    },
    finishDate: {
      isDate: value =>  moment(value, 'DD.MM.YYYY').isValid(),
      isBeforeDate(value) {
        return moment(value, 'DD.MM.YYYY')
          .isSameOrAfter(moment(this.startDate, 'DD.MM.YYYY'));
      },
    },
  },
  watch: {
    startDate() {
      this.$store.dispatch('resetTimeId');
    },
    finishDate() {
      this.$store.dispatch('resetTimeId');
    },
  },
  methods: {
    runLoadReports() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.$store.dispatch('addReport');
      }
    },
  },
};
</script>
